#include <iom16.h>
#define MISO  PINB_Bit5
#define MOSI  PORTB_Bit6 
#define CSN   PORTB_Bit2
#define SCK   PORTB_Bit7
#define CE    PORTB_Bit1

char sta;
//*********************************************NRF24L01*************************************
#define TX_ADR_WIDTH    5   	// 5 uints TX address width
#define RX_ADR_WIDTH    5   	// 5 uints RX address width
#define TX_PLOAD_WIDTH  32  	// 20 uints TX payload
#define RX_PLOAD_WIDTH  32  	// 20 uints TX payload
char  TX_ADDRESS[TX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0x01};	//صַ
char  RX_ADDRESS[RX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0x01};	//յַ
//***************************************NRF24L01Ĵָ*******************************************************
#define READ_REG        0x00  	// Ĵָ
#define WRITE_REG       0x20 	// дĴָ
#define RD_RX_PLOAD     0x61  	// ȡָ
#define WR_TX_PLOAD     0xA0  	// дָ
#define FLUSH_TX        0xE1 	// ϴ FIFOָ
#define FLUSH_RX        0xE2  	// ϴ FIFOָ
#define REUSE_TX_PL     0xE3  	// ظװָ
#define NOP1             0xFF  	// 
//*************************************SPI(nRF24L01)Ĵַ****************************************************
#define CONFIG          0x00  // շ״̬CRCУģʽԼշ״̬Ӧʽ
#define EN_AA           0x01  // ԶӦ
#define EN_RXADDR       0x02  // ŵ
#define SETUP_AW        0x03  // շַ
#define SETUP_RETR      0x04  // Զط
#define RF_CH           0x05  // Ƶ
#define RF_SETUP        0x06  // ʡĹ
#define STATUS          0x07  // ״̬Ĵ
#define OBSERVE_TX      0x08  // ͼ⹦
#define CD              0x09  // ַ           
#define RX_ADDR_P0      0x0A  // Ƶ0ݵַ
#define RX_ADDR_P1      0x0B  // Ƶ1ݵַ
#define RX_ADDR_P2      0x0C  // Ƶ2ݵַ
#define RX_ADDR_P3      0x0D  // Ƶ3ݵַ
#define RX_ADDR_P4      0x0E  // Ƶ4ݵַ
#define RX_ADDR_P5      0x0F  // Ƶ5ݵַ
#define TX_ADDR         0x10  // ͵ַĴ
#define RX_PW_P0        0x11  // Ƶ0ݳ
#define RX_PW_P1        0x12  // Ƶ0ݳ
#define RX_PW_P2        0x13  // Ƶ0ݳ
#define RX_PW_P3        0x14  // Ƶ0ݳ
#define RX_PW_P4        0x15  // Ƶ0ݳ
#define RX_PW_P5        0x16  // Ƶ0ݳ
#define FIFO_STATUS     0x17  // FIFOջջ״̬Ĵ
//**************************************************************************************
void Delay(int s);
void inerDelay_us(char n);
void init_NRF24L01(void);
char SPI_RW(char data);
char SPI_Read(char reg);
char SPI_RW_Reg(char reg, char value);
char SPI_Read_Buf(char reg, char *pBuf, char uchars);
char SPI_Write_Buf(char reg, char *pBuf, char uchars);
void SetRX_Mode(void);
char nRF24L01_RxPacket(char* rx_buf);
void nRF24L01_TxPacket(char * tx_buf);
//*****************************************ʱ*****************************************
void Delay(int s)
{
	unsigned int i;
	for(i=0; i<s; i++);
	for(i=0; i<s; i++);
}
/******************************************************************************************
*ʱ
*****************************************************************************************/
void inerDelay_us(char n)
{
	for(;n>0;n--);

}

/****************************************************************************************************
*uint SPI_RW(uint uchar)
*ܣNRF24L01SPIдʱ
****************************************************************************************************/
char SPI_RW(char data)
{
	char i,temp=0;
   	for(i=0;i<8;i++) // output 8-bit
   	{
	if(data & 0x80)
	{
		MOSI =1 ;         // output 'uchar', MSB to MOSI
	}
	else
	{
	 	MOSI = 0; 
	}	
		data = (data << 1);           // shift next bit into MSB..
		temp<<=1;
		SCK = 1 ;                      // Set SCK high..
		if(MISO&0X20 )temp++;       		  // capture current MISO bit
		SCK = 0;            		  // ..then set SCK low again
   	}
    return(temp);           		  // return read uchar
}
/****************************************************************************************************
*uchar SPI_Read(uchar reg)
*ܣNRF24L01SPIʱ
****************************************************************************************************/
char SPI_Read(char reg)
{
	char reg_val;
	
	CSN =0;                // CSN low, initialize SPI communication...
	SPI_RW(reg);            // Select register to read from..
	reg_val = SPI_RW(0);    // ..then read registervalue
	CSN =1;                // CSN high, terminate SPI communication
	
	return(reg_val);        // return register value
}
/****************************************************************************************************
*ܣNRF24L01дĴ
****************************************************************************************************/
char SPI_RW_Reg(char reg, char value)
{
	char status;
	
	CSN = 0;                   // CSN low, init SPI transaction
	status = SPI_RW(reg);      // select register
	SPI_RW(value);             // ..and write value to it..
	CSN = 1;                   // CSN high again
	
	return(status);            // return nRF24L01 status uchar
}
/****************************************************************************************************
*uint SPI_Read_Buf(uchar reg, uchar *pBuf, uchar uchars)
*: ڶݣregΪĴַpBufΪݵַucharsݵĸ
****************************************************************************************************/
char SPI_Read_Buf(char reg, char *pBuf, char uchars)
{
	int status,uchar_ctr;
	
	CSN = 0;                    		// Set CSN low, init SPI tranaction
	status = SPI_RW(reg);       		// Select register to write to and read status uchar
	
	for(uchar_ctr=0;uchar_ctr<uchars;uchar_ctr++)
		pBuf[uchar_ctr] = SPI_RW(0);    // 
	
	CSN = 1;                           
	
	return(status);                    // return nRF24L01 status uchar
}
/*********************************************************************************************************
*uint SPI_Write_Buf(uchar reg, uchar *pBuf, uchar uchars)
*: дݣΪĴַpBufΪдݵַucharsдݵĸ
*********************************************************************************************************/
char SPI_Write_Buf(char reg, char *pBuf, char uchars)
{
	char status,uchar_ctr;
	
	CSN = 0;             //SPIʹ       
	status = SPI_RW(reg);   
	for(uchar_ctr=0; uchar_ctr<uchars; uchar_ctr++) //
	SPI_RW(*pBuf++);
	CSN = 1;           //رSPI
	return(status);    		  // 
}
/****************************************************************************************************
*void SetRX_Mode(void)
*ܣݽ 
****************************************************************************************************/
void SetRX_Mode(void)
{
	CE = 0;
	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0f);   		// IRQշжӦ16λCRC	
	CE = 1; 
	inerDelay_us(130);
}
/******************************************************************************************************
*unsigned char nRF24L01_RxPacket(unsigned char* rx_buf)
*ܣݶȡrx_bufջ
******************************************************************************************************/
char nRF24L01_RxPacket(char* rx_buf)
{
    char revale=0;
	sta=SPI_Read(STATUS);	// ȡ״̬Ĵжݽ״
	if(sta&0x40)				// жǷյ
	{
	    CE = 0; 			//SPIʹ
		SPI_Read_Buf(RD_RX_PLOAD,rx_buf,TX_PLOAD_WIDTH);// read receive payload from RX_FIFO buffer
		revale =1;			//ȡɱ־
	}
	SPI_RW_Reg(WRITE_REG+STATUS,sta);   //յݺRX_DR,TX_DS,MAX_PTøΪ1ͨд1жϱ־
	return revale;
}
/***********************************************************************************************************
*void nRF24L01_TxPacket(char * tx_buf)
*ܣ tx_buf
**********************************************************************************************************/
void nRF24L01_TxPacket(char * tx_buf)
{
	CE = 0;			//StandBy Iģʽ	
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH); // װؽն˵ַ
	SPI_Write_Buf(WR_TX_PLOAD, tx_buf, TX_PLOAD_WIDTH); 			 // װ	
//	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0e);   		 // IRQշжӦ16λCRC
	CE = 1;		 //øCEݷ
	inerDelay_us(10);
}
/****************************************************************************************
*NRF24L01ʼ
***************************************************************************************/
void init_NRF24L01(void)
{
    inerDelay_us(100);
 	CE =0;    // chip enable
 	CSN =1;   // Spi disable 
 	SCK = 0;   // Spi clock line init high
	SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);    // дصַ	
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, RX_ADDRESS, RX_ADR_WIDTH); // дն˵ַ
	SPI_RW_Reg(WRITE_REG + EN_AA, 0x01);      //  Ƶ0Զ	ACKӦ	
	SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);  //  յַֻƵ0ҪƵԲοPage21  
	SPI_RW_Reg(WRITE_REG + RF_CH, 0);        //   ŵΪ2.4GHZշһ
	SPI_RW_Reg(WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ32ֽ
	SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x07);   		//÷Ϊ1MHZ书Ϊֵ0dB	
	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0e);   		 // IRQշжӦ16λCRC

}

   
		